/*
 * Copyright 2014 CyberVision, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Autogenerated by Avro
 * 
 * DO NOT EDIT DIRECTLY
 */
package org.kaaproject.kaa.common.endpoint.gen;  
@SuppressWarnings("all")
@org.apache.avro.specific.AvroGenerated
public class ProfileUpdateRequest extends org.apache.avro.specific.SpecificRecordBase implements org.apache.avro.specific.SpecificRecord {
  public static final org.apache.avro.Schema SCHEMA$ = new org.apache.avro.Schema.Parser().parse("{\"type\":\"record\",\"name\":\"ProfileUpdateRequest\",\"namespace\":\"org.kaaproject.kaa.common.endpoint.gen\",\"fields\":[{\"name\":\"applicationToken\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"endpointPublicKeyHash\",\"type\":\"bytes\"},{\"name\":\"profileBody\",\"type\":\"bytes\"},{\"name\":\"acceptedUnicastNotifications\",\"type\":[{\"type\":\"array\",\"items\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},\"null\"]},{\"name\":\"topicStates\",\"type\":[{\"type\":\"array\",\"items\":{\"type\":\"record\",\"name\":\"TopicState\",\"fields\":[{\"name\":\"topicId\",\"type\":{\"type\":\"string\",\"avro.java.string\":\"String\"}},{\"name\":\"seqNumber\",\"type\":\"int\"}]}},\"null\"]},{\"name\":\"versionInfo\",\"type\":{\"type\":\"record\",\"name\":\"EndpointVersionInfo\",\"fields\":[{\"name\":\"configVersion\",\"type\":\"int\"},{\"name\":\"profileVersion\",\"type\":\"int\",\"default\":\"1\"},{\"name\":\"systemNfVersion\",\"type\":\"int\",\"default\":\"0\"},{\"name\":\"userNfVersion\",\"type\":\"int\",\"default\":\"0\"}]}}]}");
  public static org.apache.avro.Schema getClassSchema() { return SCHEMA$; }
   private java.lang.String applicationToken;
   private java.nio.ByteBuffer endpointPublicKeyHash;
   private java.nio.ByteBuffer profileBody;
   private java.util.List<java.lang.String> acceptedUnicastNotifications;
   private java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> topicStates;
   private org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo versionInfo;

  /**
   * Default constructor.  Note that this does not initialize fields
   * to their default values from the schema.  If that is desired then
   * one should use {@link \#newBuilder()}. 
   */
  public ProfileUpdateRequest() {}

  /**
   * All-args constructor.
   */
  public ProfileUpdateRequest(java.lang.String applicationToken, java.nio.ByteBuffer endpointPublicKeyHash, java.nio.ByteBuffer profileBody, java.util.List<java.lang.String> acceptedUnicastNotifications, java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> topicStates, org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo versionInfo) {
    this.applicationToken = applicationToken;
    this.endpointPublicKeyHash = endpointPublicKeyHash;
    this.profileBody = profileBody;
    this.acceptedUnicastNotifications = acceptedUnicastNotifications;
    this.topicStates = topicStates;
    this.versionInfo = versionInfo;
  }

  public org.apache.avro.Schema getSchema() { return SCHEMA$; }
  // Used by DatumWriter.  Applications should not call. 
  public java.lang.Object get(int field$) {
    switch (field$) {
    case 0: return applicationToken;
    case 1: return endpointPublicKeyHash;
    case 2: return profileBody;
    case 3: return acceptedUnicastNotifications;
    case 4: return topicStates;
    case 5: return versionInfo;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }
  // Used by DatumReader.  Applications should not call. 
  @SuppressWarnings(value="unchecked")
  public void put(int field$, java.lang.Object value$) {
    switch (field$) {
    case 0: applicationToken = (java.lang.String)value$; break;
    case 1: endpointPublicKeyHash = (java.nio.ByteBuffer)value$; break;
    case 2: profileBody = (java.nio.ByteBuffer)value$; break;
    case 3: acceptedUnicastNotifications = (java.util.List<java.lang.String>)value$; break;
    case 4: topicStates = (java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState>)value$; break;
    case 5: versionInfo = (org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo)value$; break;
    default: throw new org.apache.avro.AvroRuntimeException("Bad index");
    }
  }

  /**
   * Gets the value of the 'applicationToken' field.
   */
  public java.lang.String getApplicationToken() {
    return applicationToken;
  }

  /**
   * Sets the value of the 'applicationToken' field.
   * @param value the value to set.
   */
  public void setApplicationToken(java.lang.String value) {
    this.applicationToken = value;
  }

  /**
   * Gets the value of the 'endpointPublicKeyHash' field.
   */
  public java.nio.ByteBuffer getEndpointPublicKeyHash() {
    return endpointPublicKeyHash;
  }

  /**
   * Sets the value of the 'endpointPublicKeyHash' field.
   * @param value the value to set.
   */
  public void setEndpointPublicKeyHash(java.nio.ByteBuffer value) {
    this.endpointPublicKeyHash = value;
  }

  /**
   * Gets the value of the 'profileBody' field.
   */
  public java.nio.ByteBuffer getProfileBody() {
    return profileBody;
  }

  /**
   * Sets the value of the 'profileBody' field.
   * @param value the value to set.
   */
  public void setProfileBody(java.nio.ByteBuffer value) {
    this.profileBody = value;
  }

  /**
   * Gets the value of the 'acceptedUnicastNotifications' field.
   */
  public java.util.List<java.lang.String> getAcceptedUnicastNotifications() {
    return acceptedUnicastNotifications;
  }

  /**
   * Sets the value of the 'acceptedUnicastNotifications' field.
   * @param value the value to set.
   */
  public void setAcceptedUnicastNotifications(java.util.List<java.lang.String> value) {
    this.acceptedUnicastNotifications = value;
  }

  /**
   * Gets the value of the 'topicStates' field.
   */
  public java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> getTopicStates() {
    return topicStates;
  }

  /**
   * Sets the value of the 'topicStates' field.
   * @param value the value to set.
   */
  public void setTopicStates(java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> value) {
    this.topicStates = value;
  }

  /**
   * Gets the value of the 'versionInfo' field.
   */
  public org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo getVersionInfo() {
    return versionInfo;
  }

  /**
   * Sets the value of the 'versionInfo' field.
   * @param value the value to set.
   */
  public void setVersionInfo(org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo value) {
    this.versionInfo = value;
  }

  /** Creates a new ProfileUpdateRequest RecordBuilder */
  public static org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder newBuilder() {
    return new org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder();
  }
  
  /** Creates a new ProfileUpdateRequest RecordBuilder by copying an existing Builder */
  public static org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder newBuilder(org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder other) {
    return new org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder(other);
  }
  
  /** Creates a new ProfileUpdateRequest RecordBuilder by copying an existing ProfileUpdateRequest instance */
  public static org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder newBuilder(org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest other) {
    return new org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder(other);
  }
  
  /**
   * RecordBuilder for ProfileUpdateRequest instances.
   */
  public static class Builder extends org.apache.avro.specific.SpecificRecordBuilderBase<ProfileUpdateRequest>
    implements org.apache.avro.data.RecordBuilder<ProfileUpdateRequest> {

    private java.lang.String applicationToken;
    private java.nio.ByteBuffer endpointPublicKeyHash;
    private java.nio.ByteBuffer profileBody;
    private java.util.List<java.lang.String> acceptedUnicastNotifications;
    private java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> topicStates;
    private org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo versionInfo;

    /** Creates a new Builder */
    private Builder() {
      super(org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.SCHEMA$);
    }
    
    /** Creates a Builder by copying an existing Builder */
    private Builder(org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder other) {
      super(other);
      if (isValidValue(fields()[0], other.applicationToken)) {
        this.applicationToken = data().deepCopy(fields()[0].schema(), other.applicationToken);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.endpointPublicKeyHash)) {
        this.endpointPublicKeyHash = data().deepCopy(fields()[1].schema(), other.endpointPublicKeyHash);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.profileBody)) {
        this.profileBody = data().deepCopy(fields()[2].schema(), other.profileBody);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.acceptedUnicastNotifications)) {
        this.acceptedUnicastNotifications = data().deepCopy(fields()[3].schema(), other.acceptedUnicastNotifications);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.topicStates)) {
        this.topicStates = data().deepCopy(fields()[4].schema(), other.topicStates);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.versionInfo)) {
        this.versionInfo = data().deepCopy(fields()[5].schema(), other.versionInfo);
        fieldSetFlags()[5] = true;
      }
    }
    
    /** Creates a Builder by copying an existing ProfileUpdateRequest instance */
    private Builder(org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest other) {
            super(org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.SCHEMA$);
      if (isValidValue(fields()[0], other.applicationToken)) {
        this.applicationToken = data().deepCopy(fields()[0].schema(), other.applicationToken);
        fieldSetFlags()[0] = true;
      }
      if (isValidValue(fields()[1], other.endpointPublicKeyHash)) {
        this.endpointPublicKeyHash = data().deepCopy(fields()[1].schema(), other.endpointPublicKeyHash);
        fieldSetFlags()[1] = true;
      }
      if (isValidValue(fields()[2], other.profileBody)) {
        this.profileBody = data().deepCopy(fields()[2].schema(), other.profileBody);
        fieldSetFlags()[2] = true;
      }
      if (isValidValue(fields()[3], other.acceptedUnicastNotifications)) {
        this.acceptedUnicastNotifications = data().deepCopy(fields()[3].schema(), other.acceptedUnicastNotifications);
        fieldSetFlags()[3] = true;
      }
      if (isValidValue(fields()[4], other.topicStates)) {
        this.topicStates = data().deepCopy(fields()[4].schema(), other.topicStates);
        fieldSetFlags()[4] = true;
      }
      if (isValidValue(fields()[5], other.versionInfo)) {
        this.versionInfo = data().deepCopy(fields()[5].schema(), other.versionInfo);
        fieldSetFlags()[5] = true;
      }
    }

    /** Gets the value of the 'applicationToken' field */
    public java.lang.String getApplicationToken() {
      return applicationToken;
    }
    
    /** Sets the value of the 'applicationToken' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder setApplicationToken(java.lang.String value) {
      validate(fields()[0], value);
      this.applicationToken = value;
      fieldSetFlags()[0] = true;
      return this; 
    }
    
    /** Checks whether the 'applicationToken' field has been set */
    public boolean hasApplicationToken() {
      return fieldSetFlags()[0];
    }
    
    /** Clears the value of the 'applicationToken' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder clearApplicationToken() {
      applicationToken = null;
      fieldSetFlags()[0] = false;
      return this;
    }

    /** Gets the value of the 'endpointPublicKeyHash' field */
    public java.nio.ByteBuffer getEndpointPublicKeyHash() {
      return endpointPublicKeyHash;
    }
    
    /** Sets the value of the 'endpointPublicKeyHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder setEndpointPublicKeyHash(java.nio.ByteBuffer value) {
      validate(fields()[1], value);
      this.endpointPublicKeyHash = value;
      fieldSetFlags()[1] = true;
      return this; 
    }
    
    /** Checks whether the 'endpointPublicKeyHash' field has been set */
    public boolean hasEndpointPublicKeyHash() {
      return fieldSetFlags()[1];
    }
    
    /** Clears the value of the 'endpointPublicKeyHash' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder clearEndpointPublicKeyHash() {
      endpointPublicKeyHash = null;
      fieldSetFlags()[1] = false;
      return this;
    }

    /** Gets the value of the 'profileBody' field */
    public java.nio.ByteBuffer getProfileBody() {
      return profileBody;
    }
    
    /** Sets the value of the 'profileBody' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder setProfileBody(java.nio.ByteBuffer value) {
      validate(fields()[2], value);
      this.profileBody = value;
      fieldSetFlags()[2] = true;
      return this; 
    }
    
    /** Checks whether the 'profileBody' field has been set */
    public boolean hasProfileBody() {
      return fieldSetFlags()[2];
    }
    
    /** Clears the value of the 'profileBody' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder clearProfileBody() {
      profileBody = null;
      fieldSetFlags()[2] = false;
      return this;
    }

    /** Gets the value of the 'acceptedUnicastNotifications' field */
    public java.util.List<java.lang.String> getAcceptedUnicastNotifications() {
      return acceptedUnicastNotifications;
    }
    
    /** Sets the value of the 'acceptedUnicastNotifications' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder setAcceptedUnicastNotifications(java.util.List<java.lang.String> value) {
      validate(fields()[3], value);
      this.acceptedUnicastNotifications = value;
      fieldSetFlags()[3] = true;
      return this; 
    }
    
    /** Checks whether the 'acceptedUnicastNotifications' field has been set */
    public boolean hasAcceptedUnicastNotifications() {
      return fieldSetFlags()[3];
    }
    
    /** Clears the value of the 'acceptedUnicastNotifications' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder clearAcceptedUnicastNotifications() {
      acceptedUnicastNotifications = null;
      fieldSetFlags()[3] = false;
      return this;
    }

    /** Gets the value of the 'topicStates' field */
    public java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> getTopicStates() {
      return topicStates;
    }
    
    /** Sets the value of the 'topicStates' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder setTopicStates(java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState> value) {
      validate(fields()[4], value);
      this.topicStates = value;
      fieldSetFlags()[4] = true;
      return this; 
    }
    
    /** Checks whether the 'topicStates' field has been set */
    public boolean hasTopicStates() {
      return fieldSetFlags()[4];
    }
    
    /** Clears the value of the 'topicStates' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder clearTopicStates() {
      topicStates = null;
      fieldSetFlags()[4] = false;
      return this;
    }

    /** Gets the value of the 'versionInfo' field */
    public org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo getVersionInfo() {
      return versionInfo;
    }
    
    /** Sets the value of the 'versionInfo' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder setVersionInfo(org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo value) {
      validate(fields()[5], value);
      this.versionInfo = value;
      fieldSetFlags()[5] = true;
      return this; 
    }
    
    /** Checks whether the 'versionInfo' field has been set */
    public boolean hasVersionInfo() {
      return fieldSetFlags()[5];
    }
    
    /** Clears the value of the 'versionInfo' field */
    public org.kaaproject.kaa.common.endpoint.gen.ProfileUpdateRequest.Builder clearVersionInfo() {
      versionInfo = null;
      fieldSetFlags()[5] = false;
      return this;
    }

    @Override
    public ProfileUpdateRequest build() {
      try {
        ProfileUpdateRequest record = new ProfileUpdateRequest();
        record.applicationToken = fieldSetFlags()[0] ? this.applicationToken : (java.lang.String) defaultValue(fields()[0]);
        record.endpointPublicKeyHash = fieldSetFlags()[1] ? this.endpointPublicKeyHash : (java.nio.ByteBuffer) defaultValue(fields()[1]);
        record.profileBody = fieldSetFlags()[2] ? this.profileBody : (java.nio.ByteBuffer) defaultValue(fields()[2]);
        record.acceptedUnicastNotifications = fieldSetFlags()[3] ? this.acceptedUnicastNotifications : (java.util.List<java.lang.String>) defaultValue(fields()[3]);
        record.topicStates = fieldSetFlags()[4] ? this.topicStates : (java.util.List<org.kaaproject.kaa.common.endpoint.gen.TopicState>) defaultValue(fields()[4]);
        record.versionInfo = fieldSetFlags()[5] ? this.versionInfo : (org.kaaproject.kaa.common.endpoint.gen.EndpointVersionInfo) defaultValue(fields()[5]);
        return record;
      } catch (Exception e) {
        throw new org.apache.avro.AvroRuntimeException(e);
      }
    }
  }
}
