/*
 * Copyright 2014 CyberVision, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kaaproject.kaa.server.operations.service.logs;

import java.util.List;

/**
 * Service that return appenders list.
 *
 */
public interface LogAppenderService {

    /**
     * Return List of all Appenders available for Application with specific application id
     *
     * @param applicationId the application id of Application
     * @return List of all Appenders available for Application
     */
    List<LogAppender> getApplicationAppenders(String applicationId);

    LogSchema getLogSchema(String applicationId, int logSchemaVersion);
}
